export declare class ElementsModule {
    static forRoot(): {
        ngModule: typeof ElementsModule;
        providers: ({
            provide: import("@angular/core").InjectionToken<import("./elements.interfaces").ElementsIcon[]>;
            useValue: {
                namespace: string;
                className: string;
                type: string;
            };
            multi: boolean;
        } | {
            provide: import("@angular/core").InjectionToken<import("./elements.interfaces").ElementsError[]>;
            useFactory: typeof getErrors;
            multi: boolean;
        })[];
    };
}
export declare const ELEMENTS_MATERIAL_ICON: {
    provide: import("@angular/core").InjectionToken<import("./elements.interfaces").ElementsIcon[]>;
    useValue: {
        namespace: string;
        className: string;
        type: string;
    };
    multi: boolean;
};
export declare function getErrors(): {
    unknown: () => string;
    required: () => string;
    pattern: () => string;
    email: () => string;
    emailTaken: () => string;
    passwordMatch: () => string;
    fullNumber: () => string;
    min: ({ min }: {
        min: any;
    }) => {
        token: string;
        data: {
            min: any;
        };
    };
    max: ({ max }: {
        max: any;
    }) => {
        token: string;
        data: {
            max: any;
        };
    };
    maxFileSize: ({ maxSize }: {
        maxSize: any;
    }) => {
        token: string;
        data: {
            maxSize: any;
        };
    };
    minlength: ({ requiredLength, actualLength }: {
        requiredLength: any;
        actualLength: any;
    }) => {
        token: string;
        data: {
            requiredLength: any;
            actualLength: any;
        };
    };
    maxlength: ({ requiredLength, actualLength }: {
        requiredLength: any;
        actualLength: any;
    }) => {
        token: string;
        data: {
            requiredLength: any;
            actualLength: any;
        };
    };
};
