import { __read, __extends, __spread } from 'tslib';
import { Component, ChangeDetectionStrategy, ViewEncapsulation, HostBinding, Input, HostListener, Directive, ContentChildren, TemplateRef, ViewChild, forwardRef, NgModule } from '@angular/core';
import { tap, map, catchError, debounceTime, distinctUntilChanged, startWith, switchMap, share } from 'rxjs/operators';
import { DataSourceRequest } from '@bravobit/bb-foundation/api';
import { BehaviorSubject, of, combineLatest } from 'rxjs';
import { FormControl, NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ElementsModule } from '@bravobit/bb-foundation/elements';
import { mixinDisabled } from '@bravobit/bb-foundation';
import { LocalizeModule } from '@bravobit/bb-foundation/localize';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table-header-cell/table-header-cell.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTableHeaderCell = /** @class */ (function () {
    function BbTableHeaderCell() {
        // Styling.
        this.disabled = false;
        // Constants.
        this._name = null;
        this._sort = 'none';
        this._sortDirections = ['asc', 'desc', 'none'];
        // State.
        this.state = new BehaviorSubject(null);
    }
    Object.defineProperty(BbTableHeaderCell.prototype, "name", {
        get: /**
         * @return {?}
         */
        function () {
            return this._name;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._name = value;
            this.setState();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbTableHeaderCell.prototype, "sort", {
        get: /**
         * @return {?}
         */
        function () {
            return this._sort;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._sort = value;
            this.setState();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbTableHeaderCell.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.setState();
    };
    /**
     * @return {?}
     */
    BbTableHeaderCell.prototype.onClick = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Check if the header cell is disabled.
        if (this.disabled) {
            return;
        }
        // Find the index of the current sort.
        /** @type {?} */
        var index = this._sortDirections.findIndex((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item === _this.sort; }));
        // Increase the current index.
        /** @type {?} */
        var newIndex = index + 1;
        // If the sort is out of bounds set it to null.
        if (newIndex >= this._sortDirections.length) {
            newIndex = 0;
        }
        // Set the new sort.
        this.sort = this._sortDirections[newIndex];
    };
    /**
     * @return {?}
     */
    BbTableHeaderCell.prototype.setState = /**
     * @return {?}
     */
    function () {
        this.state.next({
            name: this.name,
            direction: this.sort
        });
    };
    BbTableHeaderCell.decorators = [
        { type: Component, args: [{
                    selector: 'bb-table-header-cell',
                    template: "<ng-content></ng-content>\n\n<!-- The indicator for the sort direction. -->\n<button *ngIf=\"!disabled\"\n        [class.asc]=\"sort === 'asc'\"\n        [class.desc]=\"sort === 'desc'\"\n        class=\"bb-table-header-cell-toggle\"\n        type=\"button\"></button>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: { 'class': 'bb-table-header-cell' },
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    styles: [".bb-table-header-cell{height:50px;color:#212529;cursor:pointer;font-size:16px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;padding:10px 20px;position:relative;display:table-cell;vertical-align:middle;border-bottom:1px solid #d8d8d8}.bb-table-header-cell:active>.bb-table-header-cell-toggle{background-color:rgba(0,0,0,.08)}.bb-table-header-cell:not(.disabled){padding-right:52px}.bb-table-header-cell.fit{width:1%;white-space:nowrap}.bb-table-header-cell.left{text-align:left}.bb-table-header-cell.center{text-align:center}.bb-table-header-cell.right{text-align:right}.bb-table-header-cell.disabled{cursor:default;pointer-events:none}.bb-table-header-cell-toggle{top:50%;right:14px;width:22px;border:none;height:22px;margin-left:auto;position:absolute;border-radius:4px;-ms-transform:translateY(-50%);transform:translateY(-50%);background-position:center;background-repeat:no-repeat;background-color:transparent;transition:background-color .2s cubic-bezier(0,0,.2,1);background-image:url('data:image/svg+xml,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 9 15\" width=\"9\" height=\"15\"%3E%3Cpath fill=\"%23dcdcdc\" d=\"M4.5 0L0 7h9z\"%3E%3C/path%3E%3Cpath fill=\"%23dcdcdc\" d=\"M4.5 15L9 8H0z\"%3E%3C/path%3E%3C/svg%3E')}.bb-table-header-cell-toggle.desc{background-image:url('data:image/svg+xml,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 9 15\" width=\"9\" height=\"15\"%3E%3Cpath fill=\"%23dcdcdc\" d=\"M4.5 0L0 7h9z\"%3E%3C/path%3E%3Cpath fill=\"black\" d=\"M4.5 15L9 8H0z\"%3E%3C/path%3E%3C/svg%3E')}.bb-table-header-cell-toggle.asc{background-image:url('data:image/svg+xml,%3Csvg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 9 15\" width=\"9\" height=\"15\"%3E%3Cpath fill=\"black\" d=\"M4.5 0L0 7h9z\"%3E%3C/path%3E%3Cpath fill=\"%23dcdcdc\" d=\"M4.5 15L9 8H0z\"%3E%3C/path%3E%3C/svg%3E')}"]
                }] }
    ];
    BbTableHeaderCell.propDecorators = {
        disabled: [{ type: HostBinding, args: ['class.disabled',] }, { type: Input }],
        name: [{ type: Input }],
        sort: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click',] }]
    };
    return BbTableHeaderCell;
}());
if (false) {
    /** @type {?} */
    BbTableHeaderCell.prototype.disabled;
    /**
     * @type {?}
     * @private
     */
    BbTableHeaderCell.prototype._name;
    /**
     * @type {?}
     * @private
     */
    BbTableHeaderCell.prototype._sort;
    /**
     * @type {?}
     * @private
     */
    BbTableHeaderCell.prototype._sortDirections;
    /** @type {?} */
    BbTableHeaderCell.prototype.state;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table/table.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTableColumnDef = /** @class */ (function () {
    function BbTableColumnDef() {
    }
    BbTableColumnDef.decorators = [
        { type: Directive, args: [{
                    selector: '[bbTableColumnDef]'
                },] }
    ];
    return BbTableColumnDef;
}());
var BbTable = /** @class */ (function () {
    function BbTable() {
        var _this = this;
        // Inputs.
        this.identifier = null;
        this.queryFields = [];
        // Sizes.
        this._sizes = [25, 50, 75, 100];
        // Templates.
        this._header = true;
        this._footer = true;
        // Optimizations.
        this.trackByFn = (/**
         * @param {?} index
         * @param {?} item
         * @return {?}
         */
        function (index, item) { return _this.identifier ? item[_this.identifier] : index; });
        this.trackByValue = (/**
         * @param {?} index
         * @param {?} item
         * @return {?}
         */
        function (index, item) { return item; });
        // State.
        this.queryControl = new FormControl('');
        this.sizeControl = new FormControl(this._sizes[0]);
        this.pageControl = new FormControl(1);
    }
    Object.defineProperty(BbTable.prototype, "sizes", {
        get: /**
         * @return {?}
         */
        function () {
            return this._sizes;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.updateSizes(newValue);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbTable.prototype, "header", {
        get: /**
         * @return {?}
         */
        function () {
            // If the header equals false just return null.
            if (!this._header) {
                return null;
            }
            // If the header is true use the default header.
            if (this._header === true) {
                return this.headerTemplate;
            }
            // It must be a custom header, use this.
            return this._header;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._header = newValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbTable.prototype, "footer", {
        get: /**
         * @return {?}
         */
        function () {
            // If the footer equals false just return null.
            if (!this._footer) {
                return null;
            }
            // If the footer is true use the default header.
            if (this._footer === true) {
                return this.footerTemplate;
            }
            // It must be a custom footer, use this.
            return this._footer;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._footer = newValue;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbTable.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Validate the data source exists.
        if (!this.dataSource) {
            throw new Error('The data source was not passed properly.');
        }
        // Create a new request.
        this.request = new DataSourceRequest();
        this.isLoading$ = this.request.loading;
        // Pass the request to the data source.
        this.data$ = this.dataSource.handle(this.request).pipe(tap((/**
         * @return {?}
         */
        function () { return _this.request.stopLoading(); })), map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            /** @type {?} */
            var count = (result && result.data && result.data.length) || 0;
            if (count <= 0) {
                return { state: 'success-empty', result: result };
            }
            return { state: 'success-all', result: result };
        })), catchError((/**
         * @param {?} error
         * @return {?}
         */
        function (error) {
            _this.request.stopLoading();
            if (error.status === 404) {
                return of({ state: 'error-not-found' });
            }
            if (error.status === 500) {
                return of({ state: 'error-server' });
            }
            return of({ state: 'error-unknown' });
        })));
    };
    /**
     * @return {?}
     */
    BbTable.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var queryChanges$ = this.queryControl.valueChanges.pipe(debounceTime(400), distinctUntilChanged(), startWith([this.queryControl.value]));
        /** @type {?} */
        var sortChanges$ = this.headerCells.changes.pipe(startWith(this.headerCells.toArray()), switchMap((/**
         * @param {?} headerCells
         * @return {?}
         */
        function (headerCells) { return combineLatest(headerCells.map((/**
         * @param {?} cell
         * @return {?}
         */
        function (cell) { return cell.state; }))); })), map((/**
         * @param {?} cells
         * @return {?}
         */
        function (cells) { return cells.filter((/**
         * @param {?} cell
         * @return {?}
         */
        function (cell) { return !!cell['name'] && cell['direction'] !== 'none'; })); })));
        /** @type {?} */
        var sizeChanges$ = this.sizeControl.valueChanges.pipe(startWith([this.sizeControl.value]));
        /** @type {?} */
        var pageChanges$ = this.pageControl.valueChanges.pipe(startWith([this.pageControl.value]));
        this._subscription = combineLatest([
            queryChanges$,
            sortChanges$,
            sizeChanges$,
            pageChanges$
        ]).subscribe((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 4), query = _b[0], sort = _b[1], pageSize = _b[2], pageNumber = _b[3];
            _this.request.startLoading();
            return _this.request.update({
                query: query,
                pageSize: pageSize,
                pageNumber: pageNumber,
                queryFields: _this.queryFields,
                sort: (/** @type {?} */ (sort))
            });
        }));
    };
    /**
     * @return {?}
     */
    BbTable.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._subscription && this._subscription.unsubscribe();
    };
    /**
     * @return {?}
     */
    BbTable.prototype.refresh = /**
     * @return {?}
     */
    function () {
        return this.request.update();
    };
    /**
     * @private
     * @param {?} newValue
     * @return {?}
     */
    BbTable.prototype.updateSizes = /**
     * @private
     * @param {?} newValue
     * @return {?}
     */
    function (newValue) {
        // Validate the sizes has at least one value.
        if (newValue.length <= 0) {
            throw new Error('Cannot set an empty array as the sizes.');
        }
        // Set the new size.
        this._sizes = newValue;
        // Check if the current selected value is
        // in the new sizes array.
        if (this._sizes.includes(this.sizeControl.value)) {
            return;
        }
        // Set the first value in the array as
        // the new value.
        /** @type {?} */
        var firstValue = this._sizes[0];
        this.sizeControl.setValue(firstValue);
    };
    BbTable.decorators = [
        { type: Component, args: [{
                    selector: 'bb-table',
                    template: "<!--\n    This is the header of the table. It can be a user\n    defined custom header or just the default header.\n-->\n\n<header *ngIf=\"header as headerTemplate\"\n        class=\"bb-table-top-actions\">\n    <ng-container *ngTemplateOutlet=\"headerTemplate\"></ng-container>\n</header>\n\n<!--\n    This is the table that contains the\n    rows and columns.\n-->\n\n<div class=\"bb-table-wrapper\">\n    <div *ngIf=\"isLoading$ | async\"\n         class=\"bb-table-progress\">\n        <div class=\"bb-table-indeterminate\"></div>\n    </div>\n    <table class=\"bb-table-container\">\n        <thead>\n            <tr>\n                <ng-content select=\"bb-table-header-cell\"></ng-content>\n            </tr>\n        </thead>\n        <tbody *ngIf=\"data$ | async as data; else isLoadingTemplate\"\n               [ngSwitch]=\"data?.state\">\n            <ng-container *ngSwitchCase=\"'success-all'\">\n                <tr *ngFor=\"let item of data?.result?.data; trackBy: trackByFn\">\n                    <ng-container *ngFor=\"let template of tableColumnTemplates\">\n                        <ng-container *ngTemplateOutlet=\"template; context: {item: item}\"></ng-container>\n                    </ng-container>\n                </tr>\n            </ng-container>\n\n            <ng-container *ngSwitchCase=\"'success-empty'\">\n                <ng-container\n                    *ngTemplateOutlet=\"errorTemplate; context: {content: 'tables.empty'}\"></ng-container>\n            </ng-container>\n\n            <ng-container *ngSwitchCase=\"'error-not-found'\">\n                <ng-container\n                    *ngTemplateOutlet=\"errorTemplate; context: {content: 'tables.error_not_found'}\"></ng-container>\n            </ng-container>\n\n            <ng-container *ngSwitchCase=\"'error-server'\">\n                <ng-container\n                    *ngTemplateOutlet=\"errorTemplate; context: {content: 'tables.error_server'}\"></ng-container>\n            </ng-container>\n\n            <ng-container *ngSwitchDefault>\n                <ng-container\n                    *ngTemplateOutlet=\"errorTemplate; context: {content: 'tables.error_unknown'}\"></ng-container>\n            </ng-container>\n        </tbody>\n    </table>\n</div>\n\n<footer *ngIf=\"footer as footerTemplate\"\n        class=\"bb-table-bottom-actions\">\n    <ng-container *ngTemplateOutlet=\"footerTemplate\"></ng-container>\n</footer>\n\n<ng-template #isLoadingTemplate>\n    <tr>\n        <td [attr.colspan]=\"tableColumnTemplates?.length\"\n            class=\"bb-table-template\">\n            <div class=\"bb-table-template-content\">\n                {{ 'tables.loading' | bbLocalize }}\n            </div>\n        </td>\n    </tr>\n</ng-template>\n\n<!--\n    This is the template that will be used when the user has not\n    supplied a custom header template.\n-->\n\n<ng-template #headerTemplate>\n    <ng-content></ng-content>\n    <bb-form-control>\n        <input [formControl]=\"queryControl\"\n               [placeholder]=\"'tables.search' | bbLocalize\"\n               bbInput\n               autocomplete=\"off\">\n        <bb-icon *ngIf=\"queryControl?.value?.length <= 0; else closeButtonTemplate\"\n                 bbSuffix\n                 src=\"material:search\">\n        </bb-icon>\n    </bb-form-control>\n</ng-template>\n\n<!--\n    This is the template that will be used when the user has not\n    supplied a custom footer template.\n-->\n\n<ng-template #footerTemplate>\n    <bb-form-control *ngIf=\"sizes?.length > 1\">\n        <select [formControl]=\"sizeControl\"\n                bbInput\n                title=\"Sizes\">\n            <option *ngFor=\"let item of sizes; trackBy: trackByValue\"\n                    [ngValue]=\"item\">\n                {{ item }} / {{ 'tables.page' | bbLocalize }}\n            </option>\n        </select>\n    </bb-form-control>\n\n    <bb-table-pager [totalPages]=\"(data$ | async)?.result?.totalPages\"\n                    [formControl]=\"pageControl\">\n    </bb-table-pager>\n</ng-template>\n\n<!--\n    This the template that will be used when the user\n    has filled in some data in the query control.\n-->\n\n<ng-template #closeButtonTemplate>\n    <button bbSuffix\n            (click)=\"queryControl?.patchValue('')\"\n            type=\"button\"\n            class=\"bb-table-progress-close-query\">\n        <bb-icon src=\"material:close\"></bb-icon>\n    </button>\n</ng-template>\n\n<ng-template #errorTemplate let-content=\"content\">\n    <tr>\n        <td [attr.colspan]=\"tableColumnTemplates?.length\"\n            class=\"bb-table-template\">\n            <div class=\"bb-table-template-content\">\n                <svg xmlns=\"http://www.w3.org/2000/svg\" width=\"64\" height=\"41\">\n                    <g fill=\"none\" fill-rule=\"evenodd\" transform=\"translate(0 1)\">\n                        <ellipse cx=\"32\" cy=\"33\" fill=\"#F5F5F5\" rx=\"32\" ry=\"7\"></ellipse>\n                        <g fill-rule=\"nonzero\" stroke=\"#D9D9D9\">\n                            <path\n                                d=\"M55 12.7605604L44.8543047 1.25739633C44.3674414.47382661 43.6558789 0 42.9067617 0H21.0932383c-.7491172 0-1.4606797.47395025-1.947543 1.25739633L9 12.7605604V22h46v-9.2394396z\"></path>\n                            <path fill=\"#FAFAFA\"\n                                  d=\"M41.6132813 15.9315c0-1.6056489.9936718-2.931266 2.2264179-2.9315H55v18.1371277C55 33.2589574 53.6793867 35 52.0504297 35H11.94957031C10.32052344 35 9 33.2588404 9 31.1371277V13h11.1603008c1.2327461 0 2.226418 1.3228085 2.226418 2.9284574v.0211809c0 1.6056489 1.0049921 2.9015426 2.2377382 2.9015426h14.751086c1.2327461 0 2.2377383-1.3078298 2.2377383-2.9134788V15.9315z\"></path>\n                        </g>\n                    </g>\n                </svg>\n                {{ content | bbLocalize }}\n            </div>\n        </td>\n    </tr>\n</ng-template>\n",
                    host: { 'class': 'bb-table' },
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    styles: [".bb-table{width:100%;display:block;box-shadow:0 6px 6px -6px rgba(0,0,0,.1)}.bb-table.plain{box-shadow:none}.bb-table.plain>.bb-table-wrapper{border-top-left-radius:0;border-top-right-radius:0}.bb-table-wrapper{overflow-x:auto;position:relative;background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px}.bb-table-container{width:100%}.bb-table-container td{border-bottom:1px solid #d8d8d8}.bb-table-top-actions{display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-ms-flex-direction:column;flex-direction:column;padding:20px 20px 10px;background-color:#fff;-ms-flex-pack:end;justify-content:flex-end;border-top-left-radius:4px;border-top-right-radius:4px;border-bottom:1px solid #d8d8d8}.bb-table-top-actions>*{margin-left:0;margin-bottom:10px}.bb-table-top-actions+.bb-table-wrapper{border-radius:0}.bb-table-bottom-actions{height:60px;display:-ms-flexbox;display:flex;padding:0 20px;overflow-x:auto;-ms-flex-align:center;align-items:center;background-color:#fff;border-bottom-left-radius:4px;border-bottom-right-radius:4px}.bb-table-template{border:none;background-color:#f5f5f5;border-bottom:1px solid #d8d8d8}.bb-table-template-content{padding:20px;display:-ms-flexbox;display:flex;color:#3d464d;font-size:16px;line-height:1.2;font-weight:500;min-height:140px;text-align:center;-ms-flex-align:center;align-items:center;-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:center;justify-content:center}.bb-table-template-content>svg{margin-bottom:12px}.bb-table-progress{top:0;left:0;right:0;opacity:0;width:100%;height:4px;display:block;overflow:hidden;position:absolute;background-color:rgba(47,64,139,.3);-webkit-animation:250ms cubic-bezier(0,0,.2,1) .1s forwards fadeIn;animation:250ms cubic-bezier(0,0,.2,1) .1s forwards fadeIn}.bb-table-progress .bb-table-indeterminate{background-color:#2f408b}.bb-table-progress .bb-table-indeterminate:before{top:0;left:0;bottom:0;content:\"\";position:absolute;will-change:left,right;background-color:inherit;-webkit-animation:2.1s cubic-bezier(.65,.815,.735,.395) infinite indeterminate;animation:2.1s cubic-bezier(.65,.815,.735,.395) infinite indeterminate}.bb-table-progress .bb-table-indeterminate:after{top:0;left:0;bottom:0;content:\"\";position:absolute;-webkit-animation-delay:1.15s;animation-delay:1.15s;will-change:left,right;background-color:inherit;-webkit-animation:2.1s cubic-bezier(.165,.84,.44,1) infinite indeterminate-short;animation:2.1s cubic-bezier(.165,.84,.44,1) infinite indeterminate-short}.bb-table-progress-close-query{padding:0;border:none;border-radius:4px;background-color:transparent;transition:background-color 250ms cubic-bezier(0,0,.2,1)}.bb-table-progress-close-query:hover{background-color:rgba(0,0,0,.08)}.bb-table-progress-close-query:focus{background-color:rgba(0,0,0,.12)}.bb-table-progress-close-query:active{background-color:rgba(0,0,0,.16)}@-webkit-keyframes fadeIn{from{opacity:0}to{opacity:1}}@keyframes fadeIn{from{opacity:0}to{opacity:1}}@-webkit-keyframes indeterminate{0%{left:-35%;right:100%}100%,60%{left:100%;right:-90%}}@keyframes indeterminate{0%{left:-35%;right:100%}100%,60%{left:100%;right:-90%}}@-webkit-keyframes indeterminate-short{0%{left:-200%;right:100%}100%,60%{left:107%;right:-8%}}@keyframes indeterminate-short{0%{left:-200%;right:100%}100%,60%{left:107%;right:-8%}}@media only screen and (min-width:768px){.bb-table-top-actions{-ms-flex-direction:row;flex-direction:row}.bb-table-top-actions>:not(:first-child){margin-left:10px;margin-bottom:10px}}"]
                }] }
    ];
    BbTable.propDecorators = {
        headerCells: [{ type: ContentChildren, args: [BbTableHeaderCell,] }],
        tableColumnTemplates: [{ type: ContentChildren, args: [BbTableColumnDef, { read: TemplateRef },] }],
        headerTemplate: [{ type: ViewChild, args: ['headerTemplate', { static: true, read: TemplateRef },] }],
        footerTemplate: [{ type: ViewChild, args: ['footerTemplate', { static: true, read: TemplateRef },] }],
        identifier: [{ type: Input }],
        dataSource: [{ type: Input }],
        queryFields: [{ type: Input }],
        sizes: [{ type: Input }],
        header: [{ type: Input }],
        footer: [{ type: Input }]
    };
    return BbTable;
}());
if (false) {
    /** @type {?} */
    BbTable.prototype.headerCells;
    /** @type {?} */
    BbTable.prototype.tableColumnTemplates;
    /** @type {?} */
    BbTable.prototype.headerTemplate;
    /** @type {?} */
    BbTable.prototype.footerTemplate;
    /** @type {?} */
    BbTable.prototype.identifier;
    /** @type {?} */
    BbTable.prototype.dataSource;
    /** @type {?} */
    BbTable.prototype.queryFields;
    /**
     * @type {?}
     * @private
     */
    BbTable.prototype._sizes;
    /**
     * @type {?}
     * @private
     */
    BbTable.prototype._header;
    /**
     * @type {?}
     * @private
     */
    BbTable.prototype._footer;
    /** @type {?} */
    BbTable.prototype.trackByFn;
    /** @type {?} */
    BbTable.prototype.trackByValue;
    /** @type {?} */
    BbTable.prototype.request;
    /** @type {?} */
    BbTable.prototype.data$;
    /** @type {?} */
    BbTable.prototype.isLoading$;
    /** @type {?} */
    BbTable.prototype.queryControl;
    /** @type {?} */
    BbTable.prototype.sizeControl;
    /** @type {?} */
    BbTable.prototype.pageControl;
    /**
     * @type {?}
     * @private
     */
    BbTable.prototype._subscription;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table-cell/table-cell.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTableCell = /** @class */ (function () {
    function BbTableCell() {
    }
    BbTableCell.decorators = [
        { type: Component, args: [{
                    selector: 'bb-table-cell',
                    template: "<div>\n    <ng-content></ng-content>\n</div>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: { 'class': 'bb-table-cell' },
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    styles: [".bb-table-cell{color:#848f99;font-size:14px;text-align:left;line-height:1.2;font-weight:400;padding:12px 20px;display:table-cell;word-wrap:break-word;vertical-align:middle;background-color:#f5f5f5;border-bottom:1px solid #d8d8d8}.bb-table-cell:not(:last-child){border-right:1px solid #d8d8d8}.bb-table-cell.fit{width:1%;white-space:nowrap}.bb-table-cell.left{text-align:left}.bb-table-cell.center{text-align:center}.bb-table-cell.right{text-align:right}"]
                }] }
    ];
    return BbTableCell;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table-pager/table-pager.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTablePagerBase = /** @class */ (function () {
    function BbTablePagerBase() {
    }
    return BbTablePagerBase;
}());
/** @type {?} */
var BbTablePagerMixinBase = mixinDisabled(BbTablePagerBase);
var BbTablePager = /** @class */ (function (_super) {
    __extends(BbTablePager, _super);
    function BbTablePager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // Inputs.
        _this.amountOfButtons = 5;
        _this.showArrowButtons = true;
        // Methods.
        _this.onChange = (/**
         * @return {?}
         */
        function () { return ({}); });
        _this.onTouched = (/**
         * @return {?}
         */
        function () { return ({}); });
        _this.trackByIndex = (/**
         * @param {?} index
         * @param {?} item
         * @return {?}
         */
        function (index, item) { return item.page; });
        // Data.
        _this._totalPages$ = new BehaviorSubject(1);
        _this._pageNumber$ = new BehaviorSubject(1);
        return _this;
    }
    /**
     * @return {?}
     */
    BbTablePager.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Validate the previous button is disabled.
        this.isPreviousDisabled$ = this._pageNumber$.pipe(map((/**
         * @param {?} pageNumber
         * @return {?}
         */
        function (pageNumber) { return pageNumber === 1; })));
        // Validate the next button is disabled.
        this.isNextDisabled$ = combineLatest([this._pageNumber$, this._totalPages$]).pipe(map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), pageNumber = _b[0], totalPages = _b[1];
            return pageNumber === totalPages;
        })));
        // Create the list with page numbers.
        this.list$ = combineLatest([this._pageNumber$, this._totalPages$]).pipe(map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), pageNumber = _b[0], totalPages = _b[1];
            return _this.filterActivePages(pageNumber, totalPages);
        })), share());
    };
    Object.defineProperty(BbTablePager.prototype, "pageNumber", {
        get: /**
         * @return {?}
         */
        function () {
            return this._pageNumber$.getValue();
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.update(newValue);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbTablePager.prototype, "totalPages", {
        get: /**
         * @return {?}
         */
        function () {
            return this._totalPages$.getValue();
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            /** @type {?} */
            var newTotalPages = Math.max(1, newValue);
            this._totalPages$.next(newTotalPages);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} fn
     * @return {?}
     */
    BbTablePager.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    BbTablePager.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    BbTablePager.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} newValue
     * @return {?}
     */
    BbTablePager.prototype.writeValue = /**
     * @param {?} newValue
     * @return {?}
     */
    function (newValue) {
        this.update(newValue, false);
    };
    /**
     * @return {?}
     */
    BbTablePager.prototype.goToPrevious = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var newValue = this._pageNumber$.getValue() - 1;
        return this.update(newValue);
    };
    /**
     * @return {?}
     */
    BbTablePager.prototype.goToNext = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var newValue = this._pageNumber$.getValue() + 1;
        return this.update(newValue);
    };
    /**
     * @param {?} index
     * @return {?}
     */
    BbTablePager.prototype.goToIndex = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        return this.update(index);
    };
    /**
     * @private
     * @param {?} pageNumber
     * @param {?=} notify
     * @return {?}
     */
    BbTablePager.prototype.update = /**
     * @private
     * @param {?} pageNumber
     * @param {?=} notify
     * @return {?}
     */
    function (pageNumber, notify) {
        if (notify === void 0) { notify = true; }
        // You can only update when not disabled.
        if (this.disabled) {
            return;
        }
        // Calculate the new value.
        /** @type {?} */
        var newValue = Math.min(this.totalPages, Math.max(1, pageNumber));
        // Don't do anything if the page number is the same.
        if (this._pageNumber$.getValue() === newValue) {
            return;
        }
        // Push the new value.
        this._pageNumber$.next(newValue);
        if (notify) {
            return this.onChange(pageNumber);
        }
    };
    /**
     * @private
     * @param {?} pageNumber
     * @return {?}
     */
    BbTablePager.prototype.calculatePages = /**
     * @private
     * @param {?} pageNumber
     * @return {?}
     */
    function (pageNumber) {
        /** @type {?} */
        var min = 1;
        /** @type {?} */
        var max = this.totalPages;
        /** @type {?} */
        var amount = Math.max(1, this.amountOfButtons);
        /** @type {?} */
        var data = Array(amount)
            .fill(0)
            .map((/**
         * @param {?} _
         * @param {?} index
         * @return {?}
         */
        function (_, index) { return pageNumber + (index - 1); }));
        // Validate if the minimum value less than
        // the first value.
        if (data[0] < min) {
            return data.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item + 1; }));
        }
        // Calculate the difference with the max
        // if this value is higher than 0 we should minus it.
        /** @type {?} */
        var lastValueInArray = data[data.length - 1];
        /** @type {?} */
        var differenceWithMax = lastValueInArray - max;
        if (differenceWithMax > 0) {
            return data.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item - differenceWithMax; }));
        }
        // Just return the default data.
        return data;
    };
    /**
     * @private
     * @param {?} pageNumber
     * @param {?} totalPages
     * @return {?}
     */
    BbTablePager.prototype.filterActivePages = /**
     * @private
     * @param {?} pageNumber
     * @param {?} totalPages
     * @return {?}
     */
    function (pageNumber, totalPages) {
        return this.calculatePages(pageNumber)
            .filter((/**
         * @param {?} page
         * @return {?}
         */
        function (page) { return page > 0 && page <= totalPages; }))
            .map((/**
         * @param {?} page
         * @return {?}
         */
        function (page) { return ({ page: page, active: pageNumber === page }); }));
    };
    BbTablePager.decorators = [
        { type: Component, args: [{
                    selector: 'bb-table-pager',
                    template: "<ul class=\"bb-pager-list\">\n    <!-- The previous page arrow button. -->\n    <li *ngIf=\"showArrowButtons\"\n        class=\"bb-pager-list-item\"\n        title=\"Previous page\">\n        <button [disabled]=\"isPreviousDisabled$ | async\"\n                (click)=\"goToPrevious()\"\n                class=\"bb-pager-list-button\"\n                type=\"button\">\n            <bb-icon src=\"material:keyboard_arrow_left\"></bb-icon>\n        </button>\n    </li>\n\n    <!-- The list of number buttons to navigate through the list. -->\n    <ng-container *ngIf=\"list$ | async as list\">\n        <li *ngFor=\"let item of list; trackBy: trackByIndex\"\n            [title]=\"'Page ' + item?.page\"\n            class=\"bb-pager-list-item\">\n            <button (click)=\"goToIndex(item?.page)\"\n                    [class.active]=\"item?.active\"\n                    class=\"bb-pager-list-button\"\n                    type=\"button\">\n                {{ item?.page }}\n            </button>\n        </li>\n    </ng-container>\n\n    <!-- The next page arrow button. -->\n    <li *ngIf=\"showArrowButtons\"\n        class=\"bb-pager-list-item\"\n        title=\"Next page\">\n        <button [disabled]=\"isNextDisabled$ | async\"\n                (click)=\"goToNext()\"\n                class=\"bb-pager-list-button\"\n                type=\"button\">\n            <bb-icon src=\"material:keyboard_arrow_right\"></bb-icon>\n        </button>\n    </li>\n</ul>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'bb-table-pager',
                        '[class.disabled]': 'disabled'
                    },
                    inputs: ['disabled'],
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BbTablePager; })), multi: true }
                    ],
                    styles: [".bb-table-pager{-ms-flex:1;flex:1;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:end;justify-content:flex-end}.bb-table-pager.disabled{opacity:.5;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;pointer-events:none}.bb-pager-list{display:-ms-flexbox;display:flex}.bb-pager-list-item{margin-left:8px}.bb-pager-list-button{padding:0;color:#3d464d;line-height:1;min-width:32px;font-size:16px;-webkit-appearance:none;-moz-appearance:none;appearance:none;font-weight:500;min-height:32px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;border-radius:4px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:center;justify-content:center;border:1px solid #b6bbc1;transition-duration:.2s;background-color:transparent;transition-timing-function:cubic-bezier(0,0,.2,1);transition-property:color,border-color,opacity,background-color;box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1)}.bb-pager-list-button:focus,.bb-pager-list-button:hover{background-color:rgba(0,0,0,.04)}.bb-pager-list-button.active,.bb-pager-list-button.active:hover{color:#2196f3;cursor:default;border-color:#2196f3;background-color:transparent}.bb-pager-list-button:disabled{opacity:.35;cursor:default;pointer-events:none}"]
                }] }
    ];
    BbTablePager.propDecorators = {
        amountOfButtons: [{ type: Input }],
        showArrowButtons: [{ type: Input }],
        pageNumber: [{ type: Input }],
        totalPages: [{ type: Input }]
    };
    return BbTablePager;
}(BbTablePagerMixinBase));
if (false) {
    /** @type {?} */
    BbTablePager.prototype.amountOfButtons;
    /** @type {?} */
    BbTablePager.prototype.showArrowButtons;
    /** @type {?} */
    BbTablePager.prototype.isPreviousDisabled$;
    /** @type {?} */
    BbTablePager.prototype.isNextDisabled$;
    /** @type {?} */
    BbTablePager.prototype.list$;
    /** @type {?} */
    BbTablePager.prototype.onChange;
    /** @type {?} */
    BbTablePager.prototype.onTouched;
    /** @type {?} */
    BbTablePager.prototype.trackByIndex;
    /**
     * @type {?}
     * @private
     */
    BbTablePager.prototype._totalPages$;
    /**
     * @type {?}
     * @private
     */
    BbTablePager.prototype._pageNumber$;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DECLARATIONS_EXPORTS = [
    BbTable,
    BbTableColumnDef,
    BbTableHeaderCell,
    BbTableCell
];
var TableModule = /** @class */ (function () {
    function TableModule() {
    }
    TableModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, FormsModule, ReactiveFormsModule, ElementsModule, LocalizeModule],
                    declarations: __spread([BbTablePager], DECLARATIONS_EXPORTS),
                    exports: __spread(DECLARATIONS_EXPORTS)
                },] }
    ];
    return TableModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: bravobit-bb-foundation-table.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BbTable, BbTableCell, BbTableColumnDef, BbTableHeaderCell, TableModule, BbTablePager as ɵa };
//# sourceMappingURL=bravobit-bb-foundation-table.js.map
